/*
   Solution to CS 40400 / CS 59000-01 homework assignment 1.
*/
import java.io.*;
import java.util.Scanner;

public class Hw1_BackEnd
{
   public static void main(String[] args)
   {
      // Check for three command line arguments.
      if ( 3 != args.length )
      {
         System.err.println("Usage: java BackEnd {income|population|lifeExpectancy} <year> {total|avg|max|min|count}");
         System.exit(1);
      }
      // Get the three command line arguments.
      String field     = args[0];
      String year      = args[1];
      String operation = args[2];
      // Check that the field and operation arguments make sense.
      if ( !( (field.equals("income")
             ||field.equals("population")
             ||field.equals("lifeExpectancy"))
           && (operation.equals("total")
             ||operation.equals("avg")
             ||operation.equals("max")
             ||operation.equals("min")
             ||operation.equals("count")) ) )
      {
         System.err.println("Usage: java BackEnd {income|population|lifeExpectancy} <year> {total|avg|max|min|count}");
         System.err.println("field = "+field+", year = "+year+", operation = "+operation);
         System.exit(1);
      }

      Scanner stdin = new Scanner(System.in);

      int lineCount = 0;   // count the number of nations
      int valueCount = 0;  // count the number of nations with a value for year
      double result = 0;   // the final result
      // choose the right initial value for result
      if ( operation.equals("min") )
         result = Double.MAX_VALUE;

      while(stdin.hasNextLine())
      {
         lineCount++;
         String oneNation = stdin.nextLine();

         int index1 = oneNation.indexOf("income");
         int index2 = oneNation.indexOf("population");
         int index3 = oneNation.indexOf("lifeExpectancy");

         // Search for a value for the desired year from the desired field.
         String value = null;
         if ( field.equals("income") )
            value = lookUpBetween(oneNation, year, index1, index2);

         else if ( field.equals("population") )
            value = lookUpBetween(oneNation, year, index2, index3);

         else if ( field.equals("lifeExpectancy") )
            value = lookUpBetween(oneNation, year, index3, oneNation.length());

         double v = 0;
         if ( null != value ) // If we found a value.
         {  // Parse the value for the desired year from the desired field.
            try
            {
               v = Double.parseDouble(value);
               valueCount++;
            }
            catch (NumberFormatException e)
            {  System.out.println( e );
               System.exit(1);
            }
            // Do the desired operation with this value.
            if ( operation.equals("total") || operation.equals("avg") )
            {
               result += v;
            }
            else if ( operation.equals("max") )
            {
               if (v > result)
                  result = v;
            }
            else if ( operation.equals("min") )
            {
               if (0 < v && v < result)
                  result = v;
            }
            else if ( operation.equals("count") )
            {
               result += 1;
            }
         }
      }// proces the next line of data

      // If needed, compute the average.
      if ( operation.equals("avg") )
         result = result / valueCount;

      // "Return" the result to the "calling" program.
      System.out.println( "countries counted = " + lineCount );
      System.out.println( "countries counted in result = " + valueCount );
      System.out.printf( "result = %1$f\n", result );
   }//main()


   public static String lookUpBetween(String oneNation, String year, int index1, int index2)
   {
      int index4 = oneNation.indexOf( "["+year+",", index1 );
      if (index4 >= 0 && index4 <= index2)
      {
         int index5 = oneNation.indexOf(",", index4);
         int index6 = oneNation.indexOf("]", index5);
         return oneNation.substring(index5 + 1, index6);
      }
      else
         return null;
   }

}//Hw1_BackEnd