/*
   Solution to CS 40400 / CS 59000-01 homework assignment 1.
*/
import java.io.*;
import java.util.Scanner;

public class Hw1_Query
{
   public static void main(String[] args) throws IOException, InterruptedException
   {
      // Set the default values.
      String pattern   = "name";
      String field     = "population";
      String year      = "2008";
      String operation = "count";

      // Override the default values with values from the configuration file.
      try
      {  // open the configuration file
         Scanner fileInput = new Scanner( new File("hw1_query.cfg") );
         if (fileInput.hasNextLine())
         {  // read the first line of the config file
            pattern = fileInput.nextLine();
         }
         if (fileInput.hasNextLine())
         {  // read the second line of the config file
            field = fileInput.nextLine();
         }
         if (fileInput.hasNextLine())
         {  // read the third line of the config file
            year = fileInput.nextLine();
         }
         if (fileInput.hasNextLine())
         {  // read the fourth line of the config file
            operation = fileInput.nextLine();
         }
      }
      catch (Exception e)
      {  // ignore the configuration file
      }

      // Override the current values with environment variable values
      String pattern_value = System.getenv( "CS404-pattern" );
      if (pattern_value != null ) pattern = pattern_value;
      String field_value = System.getenv( "CS404-field" );
      if (field_value != null ) field = field_value;
      String yr_value = System.getenv( "CS404-yr" );
      if (yr_value != null ) year = yr_value;
      String op_value = System.getenv( "CS404-op" );
      if (op_value != null ) operation = op_value;

      // Get the command line arguments.
      if ( args.length % 2 != 0 ) // there must be an even number of arguments
      {
         System.err.println("Usage: java Query [-p <pattern>] [-f {income|population|lifeExpectancy}] [-yr <year>] [-op {total|avg|max|min|count}]");
         System.exit(1);
      }
      if (args.length > 0)
      {
         int argIndex = 0;
         while (argIndex < args.length)
         {  // Get an (option, value) pair.
            String option = args[argIndex++];
            String value  = args[argIndex++];
            if ( option.equals("-p") )
            {
               pattern = value;
            }
            else if ( option.equals("-f") )
            {
               field = value;
            }
            else if ( option.equals("-yr") )
            {
               year = value;
            }
            else if ( option.equals("-op") )
            {
               operation = value;
            }
         }
      }

      // Check that the field and operation arguments make sense.
      if ( !( (field.equals("income")
             ||field.equals("population")
             ||field.equals("lifeExpectancy"))
           && (operation.equals("total")
             ||operation.equals("avg")
             ||operation.equals("max")
             ||operation.equals("min")
             ||operation.equals("count")) ) )
      {
         System.err.println("Usage: java Query [-p <pattern>] [-f {income|population|lifeExpectancy}] [-yr <year>] [-op {total|avg|max|min|count}]");
         System.err.println( "pattern = " + pattern + ", field = " + field + ", year = " + year + ", operation = " + operation );
         System.exit(1);
      }

      // Create a command line for running grep
      String[] cmd1 = {"grep\\grep.exe", pattern};
      // Execute grep
      Process process1 = java.lang.Runtime.getRuntime().exec(cmd1);

      // Create a command line for running BackEnd.class
      String[] cmd2 = {"java", "Hw1_BackEnd", field, year, operation};
      // Execute BackEnd
      Process process2 = java.lang.Runtime.getRuntime().exec(cmd2);

      // Get references to the streams for sending input into each stage.
      final PrintStream stage1In = new PrintStream( process1.getOutputStream() );
      final PrintStream stage2In = new PrintStream( process2.getOutputStream() );

      // Get references to the streams for reading output from each stage.
      final Scanner stage1Out = new Scanner( process1.getInputStream() );
      final Scanner stage2Out = new Scanner( process2.getInputStream() );

      // Create a stream that reads data from the nations.json file.
      final Scanner inputFile = new Scanner( new FileInputStream( "nations.json" ) );

      // Create a "pump" between the second stage and stdout.
      new Thread(new Runnable(){public void run()
      {while (stage2Out.hasNextLine())
       {String oneLine = stage2Out.nextLine();  // read from stage two's stdout
        System.out.println( oneLine );          // write to stdout
       }}}).start();

      // Create a "pump" between the first stage and the second stage.
      new Thread(new Runnable(){public void run()
      {while(stage1Out.hasNextLine())
       {String oneLine = stage1Out.nextLine();  // read from stage one's stdout
        stage2In.println( oneLine );            // write to stage two's stdin
        //stage2In.flush();
       }stage2In.close(); //THIS IS IMPORTANT (without it process2 hangs)
      }}).start();

      // Create a "pump" between the nations.json file and
      // the input stream to the first stage of the pipeline
      new Thread(new Runnable()
      {public void run() // Implement the Runable interface.
       {while(inputFile.hasNextLine())
        {String oneLine = inputFile.nextLine(); // read from the input file
         stage1In.println( oneLine );           // write to stage one's stdin
         //stdinOfChild.flush();
        }stage1In.close(); //IMPORTANT (otherwise the pipeline hangs)
      }}).start(); //start the thread

      // Wait for the second stage process to finish its work.
      process2.waitFor();  // this throws InterruptedException
   }//main()
}//Hw1_Query